<template>
    <ion-app>
        <ion-split-pane content-id="main-content">
            <app-menu />
            <ion-router-outlet id="main-content"></ion-router-outlet>
        </ion-split-pane>
    </ion-app>
</template>

<script setup lang="ts">
import { IonApp, IonRouterOutlet, IonSplitPane } from '@ionic/vue'
import AppMenu from '@/component/AppMenu.vue'
import { useMutation, useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { UserNotification } from '@/gql/graphql'
import { toastController } from '@ionic/vue'
import { information, close } from 'ionicons/icons'

const { onResult } = useQuery(
    gql`
        query Me {
            me {
                appUser {
                    id
                    username
                    name
                    isAdmin
                    state
                    roles
                    lastLoginAt
                    createdAt
                    updatedAt
                }
                notificationList {
                    id
                    text
                    createdAt
                }
            }
        }
    `,
    null,
    { fetchPolicy: 'network-only' }
)

const { mutate } = useMutation(gql`
    mutation updateNotification($id: ID!) {
        updateUserNotification(id: $id, userNotification: { isShown: true }) {
            id
        }
    }
`)

onResult((result) => {
    result.data.me.notificationList.forEach(
        (notification: UserNotification) => {
            toastController
                .create({
                    header: notification.text,
                    position: 'top',
                    color: 'warning',
                    buttons: [
                        {
                            icon: close,
                            htmlAttributes: {
                                'aria-label': 'close',
                            },
                            role: 'cancel',
                            handler: () => {
                                mutate({ id: notification.id })
                            },
                        },
                    ],
                    icon: information,
                })
                .then((toast) => toast.present())
        }
    )
})
</script>
